Index: src/org/jboss/tools/openshift/express/internal/ui/messages/OpenShiftExpressUIMessages.properties
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/messages/OpenShiftExpressUIMessages.properties	(revision 39895)
+++ src/org/jboss/tools/openshift/express/internal/ui/messages/OpenShiftExpressUIMessages.properties	(working copy)
@@ -6,7 +6,7 @@
 #
 SHOW_IN_ACTION_GROUP=Show In
 SHOW_IN_BROWSER_ACTION=Web Browser
-DELETE_APPLICATION_ACTION=Delete Application
+DELETE_APPLICATION_ACTION=Delete Application(s)
 CREATE_APPLICATION_ACTION=New OpenShift Application
 IMPORT_APPLICATION_ACTION=Import Application
 CREATE_SERVER_ADAPTER_ACTION=Create a Server Adapter
Index: src/org/jboss/tools/openshift/express/internal/ui/action/CreateServerAdapterAction.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/action/CreateServerAdapterAction.java	(revision 39895)
+++ src/org/jboss/tools/openshift/express/internal/ui/action/CreateServerAdapterAction.java	(working copy)
@@ -44,7 +44,7 @@
 public class CreateServerAdapterAction extends AbstractAction {
 
 	public CreateServerAdapterAction() {
-		super(OpenShiftExpressUIMessages.CREATE_SERVER_ADAPTER_ACTION);
+		super(OpenShiftExpressUIMessages.CREATE_SERVER_ADAPTER_ACTION, true);
 		setImageDescriptor(OpenShiftUIActivator.getDefault().createImageDescriptor("edit.gif"));
 	}
 
Index: src/org/jboss/tools/openshift/express/internal/ui/action/EditCartridgesAction.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/action/EditCartridgesAction.java	(revision 39895)
+++ src/org/jboss/tools/openshift/express/internal/ui/action/EditCartridgesAction.java	(working copy)
@@ -28,7 +28,7 @@
 public class EditCartridgesAction extends AbstractAction {
 
 	public EditCartridgesAction() {
-		super(OpenShiftExpressUIMessages.EDIT_CARTRIDGES_ACTION);
+		super(OpenShiftExpressUIMessages.EDIT_CARTRIDGES_ACTION, true);
 		setImageDescriptor(OpenShiftUIActivator.getDefault().createImageDescriptor("task-repository-new.gif"));
 	}
 	
Index: src/org/jboss/tools/openshift/express/internal/ui/action/ImportApplicationAction.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/action/ImportApplicationAction.java	(revision 39895)
+++ src/org/jboss/tools/openshift/express/internal/ui/action/ImportApplicationAction.java	(working copy)
@@ -30,7 +30,7 @@
 public class ImportApplicationAction extends AbstractAction {
 
 	public ImportApplicationAction() {
-		super(OpenShiftExpressUIMessages.IMPORT_APPLICATION_ACTION);
+		super(OpenShiftExpressUIMessages.IMPORT_APPLICATION_ACTION, true);
 		setImageDescriptor(OpenShiftUIActivator.getDefault().createImageDescriptor("go-into.gif"));
 	}
 	
Index: src/org/jboss/tools/openshift/express/internal/ui/action/OpenInWebBrowserAction.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/action/OpenInWebBrowserAction.java	(revision 39895)
+++ src/org/jboss/tools/openshift/express/internal/ui/action/OpenInWebBrowserAction.java	(working copy)
@@ -25,7 +25,7 @@
 public class OpenInWebBrowserAction extends AbstractAction {
 
 	public OpenInWebBrowserAction() {
-		super(OpenShiftExpressUIMessages.SHOW_IN_BROWSER_ACTION);
+		super(OpenShiftExpressUIMessages.SHOW_IN_BROWSER_ACTION, true);
 		setImageDescriptor(OpenShiftUIActivator.getDefault().createImageDescriptor("open-browser.gif"));
 	}
 
Index: src/org/jboss/tools/openshift/express/internal/ui/action/DeleteConnectionAction.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/action/DeleteConnectionAction.java	(revision 39895)
+++ src/org/jboss/tools/openshift/express/internal/ui/action/DeleteConnectionAction.java	(working copy)
@@ -21,7 +21,7 @@
 public class DeleteConnectionAction extends AbstractAction {
 
 	public DeleteConnectionAction() {
-		super(OpenShiftExpressUIMessages.DELETE_CONNECTION_ACTION);
+		super(OpenShiftExpressUIMessages.DELETE_CONNECTION_ACTION, true);
 	}
 
 	@Override
Index: src/org/jboss/tools/openshift/express/internal/ui/action/ShowPropertiesAction.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/action/ShowPropertiesAction.java	(revision 39895)
+++ src/org/jboss/tools/openshift/express/internal/ui/action/ShowPropertiesAction.java	(working copy)
@@ -21,7 +21,7 @@
 public class ShowPropertiesAction extends AbstractAction {
 
 	public ShowPropertiesAction() {
-		super(OpenShiftExpressUIMessages.SHOW_PROPERTIES_VIEW_ACTION);
+		super(OpenShiftExpressUIMessages.SHOW_PROPERTIES_VIEW_ACTION, true);
 	}
 
 	/*
Index: src/org/jboss/tools/openshift/express/internal/ui/action/AbstractAction.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/action/AbstractAction.java	(revision 39895)
+++ src/org/jboss/tools/openshift/express/internal/ui/action/AbstractAction.java	(working copy)
@@ -14,6 +14,7 @@
 import org.eclipse.jface.resource.ImageDescriptor;
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.jface.viewers.ISelectionChangedListener;
+import org.eclipse.jface.viewers.ITreeSelection;
 import org.eclipse.jface.viewers.SelectionChangedEvent;
 import org.eclipse.jface.viewers.StructuredViewer;
 import org.eclipse.ui.navigator.CommonViewer;
@@ -27,10 +28,17 @@
 	protected ISelection selection = null;
 	
 	protected StructuredViewer viewer;
+	
+	private boolean enableForSingleElement = false;
 
 	public AbstractAction(String text) {
 		super(text);
 	}
+	
+	public AbstractAction(String text, boolean enableForSingleElement) {
+		super(text);
+		this.enableForSingleElement = enableForSingleElement;
+	}
 
 	public AbstractAction(String text, ImageDescriptor image) {
 		super(text, image);
@@ -42,6 +50,13 @@
 		if (source instanceof CommonViewer) {
 			this.viewer = (CommonViewer) source;
 			this.selection = ((CommonViewer) source).getSelection();
+			if(enableForSingleElement){
+				if(selection instanceof ITreeSelection && ((ITreeSelection) selection).size() == 1){
+					setEnabled(true);
+				}else{
+					setEnabled(false);
+				}
+			}
 		}
 	}
 
Index: src/org/jboss/tools/openshift/express/internal/ui/console/TailServerLogAction.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/console/TailServerLogAction.java	(revision 39895)
+++ src/org/jboss/tools/openshift/express/internal/ui/console/TailServerLogAction.java	(working copy)
@@ -55,7 +55,7 @@
 	 * Constructor
 	 */
 	public TailServerLogAction() {
-		super(OpenShiftExpressUIMessages.TAIL_SERVER_LOG_ACTION);
+		super(OpenShiftExpressUIMessages.TAIL_SERVER_LOG_ACTION, true);
 		IViewRegistry reg = PlatformUI.getWorkbench().getViewRegistry();
 		IViewDescriptor desc = reg.find(IConsoleConstants.ID_CONSOLE_VIEW);
 		setImageDescriptor(desc.getImageDescriptor());