Index: ws/tests/org.jboss.tools.ws.creation.core.test/pom.xml
===================================================================
--- ws/tests/org.jboss.tools.ws.creation.core.test/pom.xml	(revision 40708)
+++ ws/tests/org.jboss.tools.ws.creation.core.test/pom.xml	(working copy)
@@ -13,7 +13,7 @@
 	<packaging>eclipse-test-plugin</packaging>
 
 	<properties>
-		<systemProperties>-Djbosstools.test.jre.6=${jbosstools.test.jre.6} -Djbosstools.test.jre.5=${jbosstools.test.jre.5} -Djbosstools.test.jboss.home.4.2=${requirement.build.root}/jboss-4.2.3.GA</systemProperties>
+		<systemProperties>-Djbosstools.test.jre.6=${jbosstools.test.jre.6} -Djbosstools.test.jre.5=${jbosstools.test.jre.5} -Djbosstools.test.jboss.home.4.2=${project.build.directory}/requirements/jboss-4.2.3.GA</systemProperties>
 		<coverage.filter>org.jboss.tools.ws.creation.core*</coverage.filter>
 		<emma.instrument.bundles>org.jboss.tools.ws.creation.core</emma.instrument.bundles>
 	</properties>
@@ -30,6 +30,31 @@
 				</configuration>
 			</plugin>
 			<plugin>
+				<groupId>org.apache.maven.plugins</groupId>
+				<artifactId>maven-dependency-plugin</artifactId>
+				<version>2.4</version>
+				<executions>
+					<execution>
+						<id>unpack</id>
+						<phase>pre-integration-test</phase>
+						<goals>
+							<goal>unpack</goal>
+						</goals>
+						<configuration>
+							<artifactItems>
+								<artifactItem>
+									<groupId>org.jboss.jbossas</groupId>
+									<artifactId>jboss-as-dist</artifactId>
+									<version>4.2.3.GA</version>
+									<type>zip</type>
+								</artifactItem>
+							</artifactItems>
+							<outputDirectory>${project.build.directory}/requirements</outputDirectory>
+						</configuration>
+					</execution>
+				</executions>
+			</plugin>
+			<plugin>
 				<groupId>org.eclipse.tycho</groupId>
 				<artifactId>tycho-surefire-plugin</artifactId>
 				
Index: ws/tests/org.jboss.tools.ws.creation.core.test/requirements.properties
===================================================================
--- ws/tests/org.jboss.tools.ws.creation.core.test/requirements.properties	(revision 40708)
+++ ws/tests/org.jboss.tools.ws.creation.core.test/requirements.properties	(working copy)
@@ -1 +0,0 @@
-requirements=jbossas-4.2.3.GA
\ No newline at end of file
Index: ws/tests/org.jboss.tools.ws.ui.bot.test/properties/swtbot.properties
===================================================================
--- ws/tests/org.jboss.tools.ws.ui.bot.test/properties/swtbot.properties	(revision 40985)
+++ ws/tests/org.jboss.tools.ws.ui.bot.test/properties/swtbot.properties	(working copy)
@@ -1,5 +1,5 @@
 #SERVER=AS,6.0,default,../../../requirements/target/jboss-6.0.0.Final
 #SERVER=AS,7.0,default,../../../requirements/target/jboss-as-web-7.0.2.Final
-SERVER=AS,7.1,default,../../../requirements/target/jboss-as-7.1.1.Final
+SERVER=AS,7.1,default,target/requirements/jboss-as-7.1.1.Final
 #SERVER=AS,7.1,default,/home/jjankovi/Dokumenty/Red_Hat_Stuff/Runtimes/jboss-as-7.1.1.Final
 #SERVER=AS,6.0,default,/home/jjankovi/jboss-6.0.0.Final-WS
Index: ws/tests/org.jboss.tools.ws.ui.bot.test/requirements.properties
===================================================================
--- ws/tests/org.jboss.tools.ws.ui.bot.test/requirements.properties	(revision 40985)
+++ ws/tests/org.jboss.tools.ws.ui.bot.test/requirements.properties	(working copy)
@@ -1,2 +0,0 @@
-#requirements=jbossas-7.0.2.Final
-requirements=jbossas-7.1.1.Final
Index: ws/tests/org.jboss.tools.ws.ui.bot.test/pom.xml
===================================================================
--- ws/tests/org.jboss.tools.ws.ui.bot.test/pom.xml	(revision 40985)
+++ ws/tests/org.jboss.tools.ws.ui.bot.test/pom.xml	(working copy)
@@ -1,7 +1,8 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<project xmlns="http://maven.apache.org/POM/4.0.0" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd"	
+<project xmlns="http://maven.apache.org/POM/4.0.0"
+	xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd"
 	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
-	
+
 	<modelVersion>4.0.0</modelVersion>
 	<parent>
 		<groupId>org.jboss.tools.ws</groupId>
@@ -10,23 +11,50 @@
 	</parent>
 	<groupId>org.jboss.tools.ws.tests</groupId>
 	<artifactId>org.jboss.tools.ws.ui.bot.test</artifactId>
-	
+
 	<packaging>eclipse-test-plugin</packaging>
 	<properties>
 		<!-- debug option -->
-		<!-- <systemProperties>-Xdebug -Xrunjdwp:transport=dt_socket,address=8001,server=y,suspend=y -Dswtbot.test.properties.file=${project.basedir}/properties/config_files/swtbot.properties</systemProperties> -->
-		<systemProperties> -Dswtbot.test.properties.file=${project.basedir}/properties/swtbot.properties</systemProperties>
-		
-		
+		<!-- <systemProperties>-Xdebug -Xrunjdwp:transport=dt_socket,address=8001,server=y,suspend=y 
+			-Dswtbot.test.properties.file=${project.basedir}/properties/config_files/swtbot.properties</systemProperties> -->
+		<systemProperties>-Dswtbot.test.properties.file=${project.basedir}/properties/swtbot.properties</systemProperties>
+
+
 		<!-- need to manually set path to swtbot.test.properties with property -->
-		<!-- <systemProperties>-Xdebug -Xrunjdwp:transport=dt_socket,address=8001,server=y,suspend=y -Dswtbot.test.properties.file=${swtbot.properties}</systemProperties> -->
+		<!-- <systemProperties>-Xdebug -Xrunjdwp:transport=dt_socket,address=8001,server=y,suspend=y 
+			-Dswtbot.test.properties.file=${swtbot.properties}</systemProperties> -->
 		<!-- <systemProperties>-Dswtbot.test.properties.file=${swtbot.properties}</systemProperties> -->
-		
+
 	</properties>
-	
+
 	<build>
 		<plugins>
 			<plugin>
+				<groupId>org.apache.maven.plugins</groupId>
+				<artifactId>maven-dependency-plugin</artifactId>
+				<version>2.4</version>
+				<executions>
+					<execution>
+						<id>unpack</id>
+						<phase>pre-integration-test</phase>
+						<goals>
+							<goal>unpack</goal>
+						</goals>
+						<configuration>
+							<artifactItems>
+								<artifactItem>
+									<groupId>org.jboss.as</groupId>
+									<artifactId>jboss-as-dist</artifactId>
+									<version>7.1.1.Final</version>
+									<type>zip</type>
+								</artifactItem>
+							</artifactItems>
+							<outputDirectory>${project.build.directory}/requirements</outputDirectory>
+						</configuration>
+					</execution>
+				</executions>
+			</plugin>
+			<plugin>
 				<groupId>org.eclipse.tycho</groupId>
 				<artifactId>tycho-surefire-plugin</artifactId>
 				<configuration>
@@ -34,7 +62,8 @@
 					<testClass>org.jboss.tools.ws.ui.bot.test.WSAllBotTests</testClass>
 					<useUIThread>false</useUIThread>
 					<skip>${swtbot.test.skip}</skip>
-					<!-- Kill swt bot test take more than 3 hours minutes (10800 seconds) to finish -->
+					<!-- Kill swt bot test take more than 3 hours minutes (10800 seconds) 
+						to finish -->
 					<forkedProcessTimeoutInSeconds>10800</forkedProcessTimeoutInSeconds>
 					<dependencies combine.children="append">
 						<dependency>
@@ -54,32 +83,14 @@
 							<version>0.0.0</version>
 						</dependency>
 						<!-- end of workaround -->
-						<!-- 
-						<dependency>
-							<type>p2-installable-unit</type>
-							<artifactId>org.eclipse.jst.enterprise_ui.feature.feature.group</artifactId>
-							<version>0.0.0</version>
-						</dependency>
-						<dependency>
-							<type>p2-installable-unit</type>
-							<artifactId>org.eclipse.jst.web_ui.feature.feature.group</artifactId>
-							<version>0.0.0</version>
-						</dependency>
-						<dependency>
-							<type>p2-installable-unit</type>
-							<artifactId>org.eclipse.wst.web_ui.feature.feature.group</artifactId>
-							<version>0.0.0</version>
-						</dependency>
-						<dependency>
-							<type>p2-installable-unit</type>
-							<artifactId>org.eclipse.wst.ws_ui.feature.feature.group</artifactId>
-							<version>0.0.0</version>
-						</dependency>
-						<dependency>
-							<type>p2-installable-unit</type>
-							<artifactId>org.eclipse.wst.xml_ui.feature.feature.group</artifactId>
-							<version>0.0.0</version>
-						</dependency>  -->
+						<!-- <dependency> <type>p2-installable-unit</type> <artifactId>org.eclipse.jst.enterprise_ui.feature.feature.group</artifactId> 
+							<version>0.0.0</version> </dependency> <dependency> <type>p2-installable-unit</type> 
+							<artifactId>org.eclipse.jst.web_ui.feature.feature.group</artifactId> <version>0.0.0</version> 
+							</dependency> <dependency> <type>p2-installable-unit</type> <artifactId>org.eclipse.wst.web_ui.feature.feature.group</artifactId> 
+							<version>0.0.0</version> </dependency> <dependency> <type>p2-installable-unit</type> 
+							<artifactId>org.eclipse.wst.ws_ui.feature.feature.group</artifactId> <version>0.0.0</version> 
+							</dependency> <dependency> <type>p2-installable-unit</type> <artifactId>org.eclipse.wst.xml_ui.feature.feature.group</artifactId> 
+							<version>0.0.0</version> </dependency> -->
 					</dependencies>
 				</configuration>
 			</plugin>